'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fs = require('fs');

var _ethicalUtilityPath = require('ethical-utility-path');

var _ethicalUtilityResolveModuleNode = require('ethical-utility-resolve-module-node');

const source = path => (0, _fs.readFileSync)(path, 'utf8');

const resolveJSPath = (request, parent) => {
    if ((0, _ethicalUtilityResolveModuleNode.isAbsolutePackage)(request)) return (0, _ethicalUtilityResolveModuleNode.resolveNodeModule)(request);
    if ((0, _ethicalUtilityResolveModuleNode.isRelativePackage)(request)) return (0, _ethicalUtilityResolveModuleNode.resolveNodeModuleFile)(request);
    if ((0, _ethicalUtilityPath.isRelative)(request)) return (0, _ethicalUtilityResolveModuleNode.resolveRelative)(request, parent);
    return request;
};

const resolveAlias = (request, id) => {
    if ((0, _ethicalUtilityResolveModuleNode.isAbsolutePackage)(request)) {
        return id;
    }
};

const resolveJSModule = (request, parent) => {
    const path = resolveJSPath(request, parent);
    const id = (0, _ethicalUtilityResolveModuleNode.generateModuleID)(path);
    const alias = resolveAlias(request, id);
    const key = alias ? request : id;
    return { key, alias, path, source };
};

exports.default = resolveJSModule;
//# sourceMappingURL=resolve-js.js.map